// DAVToolBar.java
// $Id: DAVToolBar.java,v 1.1 2000/12/13 17:02:42 bmahe Exp $
// (c) COPYRIGHT MIT, INRIA and Keio, 2000.
// Please first read the full copyright statement in file COPYRIGHT.html

package org.w3c.jwput.gui.webdav;

import java.awt.event.*;

import javax.swing.event.EventListenerList;

import javax.swing.*;

import org.w3c.jwput.gui.*;

/**
 * @version $Revision: 1.1 $
 * @author  Benot Mah (bmahe@w3.org)
 */
public class DAVToolBar extends JToolBar implements DAVActions {

    EventListenerList listenrList = new EventListenerList();

    public void addActionListener(ActionListener al) {
	listenrList.add(ActionListener.class, al);
    }

    public void removeActionListener(ActionListener al) {
	listenrList.remove(ActionListener.class, al);
    }

    protected void fire(ActionEvent ev) {
	Object[] listeners = listenrList.getListenerList();
	// Process the listeners last to first, notifying
	// those that are interested in this event
	for (int i = listeners.length-2; i >= 0; i -= 2) {
	    if (listeners[i] == ActionListener.class) {
		// Lazily create the event:
		((ActionListener)listeners[i+1]).actionPerformed(ev);
	    }
	}
    }

    protected DAVToolBar() {
	super();
	setFloatable(false);
	build();
    }

    protected JButton getButton(String icon, 
				String text, 
				String AC,
				ActionListener al) 
    {
	Icon ic = null;
	if (icon != null) {
	    ic = Icons.getIcon(icon);
	}
	JButton b = new JButton(text, ic);
	b.setActionCommand(AC);
	b.addActionListener(al);
	return b;
    }

    protected void build() {
	ActionListener al = new ActionListener() {
	    public void actionPerformed(ActionEvent ev) {
		fire(ev);
	    }
	};

	add(getButton(null, GET_CMD,    GET_CMD,    al));
	add(getButton(null, SAVE_CMD,   SAVE_CMD,   al));
	add(getButton(null, DELETE_CMD, DELETE_CMD, al));
	add(getButton(null, COPY_CMD,   COPY_CMD,   al));
	add(getButton(null, MOVE_CMD,   MOVE_CMD,   al));
	addSeparator();
	add(getButton(null, LOCK_CMD,   LOCK_CMD,   al));
	add(getButton(null, UNLOCK_CMD, UNLOCK_CMD, al));
	addSeparator();
	add(new JLabel("http://"));
	JTextField jt = new JTextField(20);
	jt.setActionCommand(OPEN_LOCATION_CMD);
	jt.addActionListener(al);
	add(jt);
    }
    
}
