// ETagsDatabase.java
// $Id: ETagsDatabase.java,v 1.3 2000/08/17 15:07:26 bmahe Exp $
// (c) COPYRIGHT MIT, INRIA and Keio, 1999.
// Please first read the full copyright statement in file COPYRIGHT.html
package org.w3c.jwput;

import java.io.File;

/**
 * The ETagsDatabase Interface provides a way to store ETags
 * @version $Revision: 1.3 $
 * @author  Benot Mah (bmahe@w3.org)
 */
public interface ETagsDatabase {

    /**
     * Get the ETag relative to the given file which was puted at the given
     * url.
     * @param file the local file
     * @param url its url
     * @return a String instance
     */
    public String getETag(File file, String url);

    /**
     * Save the ETag into the database
     * @param file the local file
     * @param url its url
     * @param etag the ETag
     */
    public void saveETag(File file, String url, String etag);

    /**
     * Remove the ETag from the database
     * @param file the local file
     * @param url its url
     */
    public void removeETag(File file, String url);
}
