// LogDialog.java
// $Id: LogDialog.java,v 1.4 2000/08/17 15:07:27 bmahe Exp $
// (c) COPYRIGHT MIT, INRIA and Keio, 1999.
// Please first read the full copyright statement in file COPYRIGHT.html

package org.w3c.jwput.gui;

import java.awt.BorderLayout;
import java.awt.Container;
import java.awt.Component;
import java.awt.Frame;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;

import javax.swing.Icon;
import javax.swing.JDialog;
import javax.swing.JButton;
import javax.swing.JPanel;
import javax.swing.JScrollBar;
import javax.swing.JScrollPane;
import javax.swing.JTextArea;
import javax.swing.BorderFactory;
import javax.swing.SwingUtilities;

import org.w3c.jwput.JWUI;

/**
 * Winie's Console.
 * @version $Revision: 1.4 $
 * @author  Benot Mah (bmahe@w3.org)
 */
public class LogDialog extends JPanel {

    protected JTextArea   area       = null;
    protected JDialog     dialog     = null;
    protected JScrollPane scrollPane = null;

    protected JWUI ui = null;

    protected String title       = null;

    /**
     * Constructor
     * @param title the Dialog title
     */    
    public LogDialog(String title, JWUI ui) {
	this.title = title;
	this.ui    = ui;
	build();
    }

    protected void build() {
	setLayout(new BorderLayout());
	setBorder(BorderFactory.createLoweredBevelBorder());
	area       = new JTextArea(10,40);
	area.setEditable(false);
	area.setLineWrap(false);
	scrollPane = new JScrollPane(area);
	add(scrollPane, "Center");
	JButton closeB = new JButton("Close console");
	closeB.addActionListener(new ActionListener() {
	    public void actionPerformed(ActionEvent e) {
		done();
	    }
	});
	JPanel p = new JPanel();
	p.add(closeB);
	add(p, "South");
    }

    public void print(String log) {
	area.append(log);
	JScrollBar scrollBar = scrollPane.getVerticalScrollBar();
	scrollBar.setValue(scrollBar.getMaximum());
    }

    public void println(String log) {
	area.append(log+"\n");
	JScrollBar scrollBar = scrollPane.getVerticalScrollBar();
	scrollBar.setValue(scrollBar.getMaximum());
    }

    protected void clean() {
	area.setText("");
    }

    protected void done() {
	if (dialog != null)
	    dialog.setVisible(false);
	ui.hidelogs();
    }

    /**
     * Show this modal dialog
     * @param comp the parent component
     */
    public void showDialog(Component parent) {
	Frame frame = (parent instanceof Frame)
	    ? (Frame) parent
	    : (Frame)SwingUtilities.getAncestorOfClass(Frame.class, parent);
	//not a modal dialog
	if (dialog == null) {
	    dialog = new JDialog(frame, title, false);
	    Container contentPane = dialog.getContentPane();
	    contentPane.setLayout(new BorderLayout());
	    contentPane.add(this, BorderLayout.CENTER);

	    dialog.pack();
	    dialog.setLocationRelativeTo(parent);
	    dialog.setLocation(300, 200);
	}
	//dialog.setSize(400,200);
        dialog.show();
    }

}
