// ByteCountListener.java
// $Id: ByteCountListener.java,v 1.3 2000/08/17 15:07:28 bmahe Exp $
// (c) COPYRIGHT MIT, INRIA and Keio, 1999.
// Please first read the full copyright statement in file COPYRIGHT.html
package org.w3c.jwput.tui;

/**
 * The ByteCountListener interface provides a way to count the bytes read
 * on a Stream
 * @version $Revision: 1.3 $
 * @author  Benot Mah (bmahe@w3.org)
 */
public interface ByteCountListener {

    /**
     * n bytes read
     * @param the number of bytes read
     */
    public void bytesRead(long n);

    /**
     * The stream has been closed
     */
    public void streamClosed();

}
