// StreamMonitor.java
// $Id: StreamMonitor.java,v 1.3 2000/08/17 15:07:28 bmahe Exp $
// (c) COPYRIGHT MIT, INRIA and Keio, 1999.
// Please first read the full copyright statement in file COPYRIGHT.html
package org.w3c.jwput.tui;

/**
 * Monitor a Stream
 * @version $Revision: 1.3 $
 * @author  Benot Mah (bmahe@w3.org)
 */
public class StreamMonitor implements ByteCountListener {

    String  message    = null;
    long    filelength = 0;
    long    start      = 0;
    long    fileK      = 0;
    int     bs         = 0;
    int     ks         = 0;

    public void bytesRead(long n) {
	int pc = (int) ((((double)n) / filelength) * 100);
	long delay = System.currentTimeMillis() - start;
	if (delay == 0)
	    return;
	if (filelength < 1024) {
	    bs = (int)((n*1000) / delay);
	    System.out.print("\r"+message+": "+pc+"% of "+filelength+
			     " bytes at "+bs+" bytes/sec");
	} else {
	    ks = (int)(((n/delay) * 1000) / 1024);
	    System.out.print("\r"+message+": "+pc+"% of "+fileK+
			     "K at "+ks+"K/sec");
	}
    }

    public void streamClosed() {
	if (filelength < 1024) {
	    long delay = System.currentTimeMillis() - start;
	    if (delay == 0)
		return;
	    bs = (int)((filelength*1000) / delay);
	    System.out.println("\r"+message+": 100% of "+filelength+
			       " bytes at "+bs+" bytes/sec\n");
	} else {
	    System.out.println("\r"+message+": 100% of "+fileK+"K at "+
			       ks+"K/sec\n");
	}
    }

    StreamMonitor (long filelength, String message) {
	this.start      = System.currentTimeMillis();
	this.filelength = filelength;
	this.fileK      = filelength/1024;
	this.message    = message;
    }

}
