// HttpLong.java
// $Id: HttpInteger.java,v 1.11 2003/02/24 10:54:49 ylafon Exp $$
// (c) COPYRIGHT MIT, ERCIM and Keio, 203.
// Please first read the full copyright statement in file COPYRIGHT.html

package org.w3c.www.http;

public class HttpLong extends BasicValue {
    Long value = null;

    protected void parse() {
	ParseState ps = new ParseState();
	ps.ioff   = 0;
	ps.bufend = raw.length;
	value = new Long(HttpParser.parseLong(raw, ps));
    }

    protected void updateByteValue() {
	HttpBuffer buf = new HttpBuffer(32);
	buf.appendLong(value.longValue());
	raw  = buf.getByteCopy();
	roff = 0;
	rlen = raw.length;
    }

    public Object getValue() {
	validate();
	return value;
    }

    public void setValue(long ival) {
	if ( value.longValue() == ival )
	    return;
	invalidateByteValue();
	value   = new Long(ival) ;
	isValid = true ;
    }

    public void setValue(Long ival) {
	if ( ival.longValue() == value.longValue() )
	    return;
	invalidateByteValue();
	value   = ival ;
	isValid = true ;
    }

    HttpLong(boolean isValid, long ival) {
	this.isValid = isValid;
	this.value   = new Long(ival) ;
    }

    public HttpLong() {
	this.isValid = false;
    }
}
